<script setup lang="ts">
import type { PhenotypeInput } from "~/utils/types/phenotype";
import { useOntologyService } from "~/composables/services/useOntologyService";

type Term = PhenotypeInput["structure"];
const props = defineProps<{ modelValue: Term }>();
const emit = defineEmits<{
  (e: "update:modelValue", v: Term): void;
}>();

const { search } = useOntologyService("TrOn");

const term = computed(() => props.modelValue);

const query = ref("");
const { data: terms, pending } = useAsyncData<Term[]>(
  async () => {
    if (!query.value) {
      return [];
    }

    return (await search(query.value, ["mixed", "concrete"])).data.map((d) => ({
      termId: d.id,
      termName: d.name,
    }));
  },
  { watch: [query] },
);

const comboboxUpdateValue = (v: string | Term) => {
  if (!v) {
    emit("update:modelValue", { termName: "" });
  } else if (typeof v === "string") {
    emit("update:modelValue", { termName: v });
  } else {
    emit("update:modelValue", v);
  }
};

const rules = [(v: Term) => !!v.termName || "Structure is required"];
</script>

<template>
  <v-combobox
    :model-value="term"
    :items="terms || []"
    :hint="term.termId"
    loading
    item-title="termName"
    item-value="termName"
    :rules="rules"
    placeholder="e.g. head"
    persistent-hint
    @update:search="(v: string) => (query = v)"
    @update:modelValue="(v: string | Term) => comboboxUpdateValue(v)"
  >
    <template #loader>
      <InputLoadingBar :loading="pending" />
    </template>
  </v-combobox>
</template>
